// ReseauxDlg.cpp : implementation file
//

#include "stdafx.h"
#include <fstream.h>
#include <afxpriv.h>
#include "Reseaux.h"
#include "ReseauxDlg.h"
#include "perceptron.hpp"
#include "Ubi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CReseauxAboutDlg : public CDialog
{
public:
	CReseauxAboutDlg();

// Dialog Data
	//{{AFX_DATA(CReseauxAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CReseauxAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CReseauxAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CReseauxAboutDlg::CReseauxAboutDlg() : CDialog(CReseauxAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CReseauxAboutDlg)
	//}}AFX_DATA_INIT
}

void CReseauxAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReseauxAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReseauxAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CReseauxAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReseauxDlg dialog

CReseauxDlg::CReseauxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReseauxDlg::IDD, pParent),
	  a_entrainer(false),
	  a_selectEntrFile(false),
	  a_modifiedNeurone(false),
	  a_perceptronP(NULL),
	  a_entree(3),
	  a_sortie(2),
	  a_neuroneCC(5),
	  a_coucheCache(4),
	  a_gain(0.5),
	  a_momentum(0.1),
	  a_minOut(0.0),
	  a_maxOut(5.0),
	  a_epsilon(0.1),
	  a_maxIter(500),
	  a_maxErreur(0.005),
	  a_tolerance(0.5)
{
	//{{AFX_DATA_INIT(CReseauxDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	a_indata[0] = 0.1543354;
	a_indata[1] = 0.155356;
	a_indata[2] = 0.144413;
}

CReseauxDlg::~CReseauxDlg()
{
	delete a_perceptronP;
}


void CReseauxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_ENTREE, a_entree);
	DDX_Text(pDX, IDC_SORTIE, a_sortie);
	DDX_Text(pDX, IDC_CACHE, a_coucheCache);
	DDX_Text(pDX, IDC_NEURONE_CACHE, a_neuroneCC);
	DDX_Text(pDX, IDC_GAIN, a_gain);
	DDX_Text(pDX, IDC_MOMENTUM, a_momentum);
	DDX_Text(pDX, IDC_MAXOUT, a_maxOut);
	DDX_Text(pDX, IDC_MINOUT, a_minOut);
	DDX_Text(pDX, IDC_EPSILON, a_epsilon);
	DDX_Text(pDX, IDC_MAXERREUR, a_maxErreur);
	DDX_Text(pDX, IDC_TOLERANCE, a_tolerance);
	DDX_Text(pDX, IDC_MAXITER, a_maxIter);
	DDX_Text(pDX, IDC_INDATA1, a_indata[0]);
	DDX_Text(pDX, IDC_INDATA2, a_indata[1]);
	DDX_Text(pDX, IDC_INDATA3, a_indata[2]);

	//{{AFX_DATA_MAP(CReseauxDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReseauxDlg, CDialog)
	//{{AFX_MSG_MAP(CReseauxDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY_RANGE(UDN_DELTAPOS, IDC_SPIN_ENTREE, IDC_SPIN_NEURONE_CC, OnSpin)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_ENTRAINER, OnEntrainer)
	ON_BN_CLICKED(IDC_ECRIREPOIDS, OnEcrirepoids)
	ON_BN_CLICKED(IDC_LIREPOIDS, OnLirepoids)
	ON_BN_CLICKED(IDC_TESTER, OnTester)
	ON_BN_CLICKED(IDC_SAVEPARAM, OnSaveparam)
	ON_BN_CLICKED(IDC_OPENPARAM, OnOpenparam)
	ON_EN_CHANGE(IDC_NEURONE_CACHE, OnChangeNeurone)
	//}}AFX_MSG_MAP
	ON_EN_CHANGE(IDC_CACHE, OnChangeNeurone)
	ON_MESSAGE(WM_KICKIDLE, OnKickIdle)
	ON_UPDATE_COMMAND_UI(IDC_TESTER, OnUpdateCommandId)
	ON_UPDATE_COMMAND_UI(IDC_ECRIREPOIDS, OnUpdateCommandId)
	ON_UPDATE_COMMAND_UI(IDC_ENTRAINER, OnUpdateCommandId)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReseauxDlg message handlers

BOOL CReseauxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	GetDlgItem(IDC_TESTER)->EnableWindow(false);
	GetDlgItem(IDC_ECRIREPOIDS)->EnableWindow(false);
	GetDlgItem(IDC_ENTRAINER)->EnableWindow(false);
	GetDlgItem(IDC_ENTREE)->EnableWindow(false);
	GetDlgItem(IDC_SORTIE)->EnableWindow(false);
	GetDlgItem(IDC_SPIN_ENTREE)->EnableWindow(false);
	GetDlgItem(IDC_SPIN_SORTIE)->EnableWindow(false);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CReseauxDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CReseauxAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CReseauxDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CReseauxDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CReseauxDlg::OnSpin(UINT nID, NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	CString buffer;
	int value;
	// TODO: Add your control notification handler code here
	GetDlgItem(nID - 4)->GetWindowText(buffer);
	value = atoi(buffer);
	if(pNMUpDown->iDelta < 0)
		value++;
	else
		if(value > 0)
			value--;

	buffer.Format("%d", value);
	GetDlgItem(nID - 4)->SetWindowText(buffer);
	if(nID == IDC_SPIN_CC || nID == IDC_SPIN_NEURONE_CC)
		a_modifiedNeurone = true;
	
	*pResult = 0;
}

void CReseauxDlg::OnBrowse() 
{
	CString pathName;
	if(BrowseFile(true, "Fichier d'entrainement (*.dat)|*.dat||", pathName))
	{
		GetDlgItem(IDC_ENTRFILE)->SetWindowText(pathName);	
		delete a_perceptronP;
		a_perceptronP = NULL;
		a_selectEntrFile = true;
	}
	else
	{
		GetDlgItem(IDC_ENTRFILE)->SetWindowText("");
		a_selectEntrFile = false;
	}
}

bool CReseauxDlg::BrowseFile(bool mOpen, CString filtre, CString& pathName)
{
	CFileDialog		fileDlg(mOpen, filtre.Right(3), NULL, 
							OFN_EXPLORER | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
							filtre, AfxGetMainWnd());

	if(fileDlg.DoModal() == IDOK)
	{
		pathName = fileDlg.GetPathName();
		return true;
	}
	return false;
}

void CReseauxDlg::OnEntrainer() 
{   
	CString entraineFile;

	UpdateData(true);
	GetDlgItem(IDC_ENTRFILE)->GetWindowText(entraineFile);
	EntraineReseaux(entraineFile);
	a_entrainer = true;
}

void CReseauxDlg::EntraineReseaux(CString weightFile)
{
	CString buffer;
	double minE = 0.0;
	double maxE = 0.0;
	Table1D<Perceptron::Data> entr;
	Table1D< Table1D<Vecteur> > data;  
	Vecteur vmin,vmax;

	TableInt couches(a_coucheCache);
	// Lit les donnes d'entrainement
    ifstream indata(weightFile,ios::in);
	if(!indata.good())
	{
		buffer.Format("Erreur d'ouverture du fichier d'entrainement (%s)", weightFile);
		AfxMessageBox(buffer, MB_OK);
		return;
	}
    entr.Lire(indata);
	indata.close();

	// Neurones couche d'entre
	couches[0] = a_entree;
	// Neurones couche de sortie
	couches[a_coucheCache - 1] = a_sortie;
	for(int i = 1;i < a_coucheCache - 1;i++)
		couches[i] = a_neuroneCC;

	// Normalisation des donnes
	for(i=0;i<entr.Dim();i++) 
	{
		if(i == 0) 
			vmin = vmax = entr[i].entree;
		else 
		{
			for(int j=0;j<vmin.Dim();j++)
			{
				if(entr[i].entree[j] < vmin[j]) 
					vmin[j] = entr[i].entree[j];
				if(entr[i].entree[j] > vmax[j]) 
					vmax[j] = entr[i].entree[j];
			}
		}
	}
    a_translation[0] = (vmin + vmax)/2;  // calcul translation vecteur d'entr
	a_translation[1].Dim(a_sortie);
	a_translation[1].Initialiser(a_minOut - a_epsilon);
    a_echelle[0].LignesCols(vmin.Dim(),vmin.Dim());
	a_echelle[0].Initialiser(0.0);
	a_echelle[1].LignesCols(a_sortie, a_sortie);
	a_echelle[1].Initialiser(0.0);
	// Calcul de l'chelle  appliquer aux entres
    for(i=0;i<vmin.Dim();i++) 
	{
      if(a_translation[0][i] != vmin[i]) 
		  a_echelle[0](i,i) = 5./(vmax[i]-vmin[i]);
      else 
		  a_echelle[0](i,i) = 1;
    }
	for(i=0;i<a_sortie;i++)
	{
		if(a_translation[1][i] != a_minOut) 
		  a_echelle[1](i,i) = 0.8/(a_maxOut - a_minOut);
		else 
		  a_echelle[1](i,i) = 1;
	}
	a_translation[1].Initialiser((a_minOut - a_epsilon) / a_echelle[1](0,0));
	for(i=0;i<entr.Dim();i++)
	{
		entr[i].entree = a_echelle[0] * (entr[i].entree - a_translation[0]);
		entr[i].desiree = a_echelle[1] * (entr[i].desiree - a_translation[1]);
	}
	ofstream out("test.ext", ios::out);
	entr.Ecrire(out);
	out << "Echelle 1" << endl;
	a_echelle[0].Ecrire(out);
	out << "Echelle 2" << endl;
	a_echelle[1].Ecrire(out);
	out << "Translation 1" << endl;
	a_translation[0].Ecrire(out);
	out << "Translation 2" << endl;
	a_translation[1].Ecrire(out);
	out.close();

	if(a_perceptronP == NULL || a_modifiedNeurone)
	{
		delete a_perceptronP;
		a_perceptronP = new Perceptron(couches, 1);
		a_modifiedNeurone = false;
	}

	a_perceptronP->InterStat(a_maxIter/100);    // initialisation des params du perceptron
	a_perceptronP->Tolerance(a_tolerance);
	a_perceptronP->Gain(a_gain);
	a_perceptronP->Momentum(a_momentum);
	a_perceptronP->MaxErreur(a_maxErreur);
	a_perceptronP->MaxIterations(a_maxIter);
	a_perceptronP->Entrainer(entr);
}

void CReseauxDlg::OnEcrirepoids() 
{
	CString fileName;
	if(a_perceptronP) 
	{
        if(BrowseFile(false, "Fichier de poids (*.wgh)|*.wgh||", fileName))
		{
			ofstream output(fileName, ios::out);
			a_echelle[0].Ecrire(output);
			a_echelle[1].Ecrire(output);
			a_translation[0].Ecrire(output);
			a_translation[1].Ecrire(output);

			a_perceptronP->Ecrire(output);
			output.close();
		}
	}
}

void CReseauxDlg::OnLirepoids() 
{
	CString fileName;
	 if(BrowseFile(true, "Fichier de poids (*.wgh)|*.wgh||", fileName))
	 {
		LirePoids(fileName);
		a_entrainer = true;
	 }
	
}

void CReseauxDlg::LirePoids(CString fileName)
{
	ifstream infile(fileName,ios::in);
	delete a_perceptronP;
	a_perceptronP = new Perceptron(1);
	a_echelle[0].Lire(infile);
	a_echelle[1].Lire(infile);
	a_translation[0].Lire(infile);
	a_translation[1].Lire(infile);
	a_perceptronP->Lire(infile);
	infile.close();
}

void CReseauxDlg::OnTester() 
{
	Vecteur retour;
	CString buffer;

	UpdateData(true);
	if(TesterReseaux(a_indata[0], a_indata[1], a_indata[2], retour))
	{
		buffer.Format("Valeur de sortie: 1-> %.3f, 2-> %.3f", retour[0], retour[1]);
		AfxMessageBox(buffer, MB_OK);
	}
	else
	{
		AfxMessageBox("Le perceptron n'est pas encore entrain ou aucun poid n'a t lu", MB_OK);
	}
}

bool CReseauxDlg::TesterReseaux(double t1, double t2, double t3, Vecteur& retour)
{
	Vecteur donnee;
	if(a_perceptronP)
	{
		donnee.Dim(3);
		donnee(0) = t1;
		donnee(1) = t2;
		donnee(2) = t3;

		a_perceptronP->PropagerAvant(a_echelle[0] * (donnee-a_translation[0]));
		retour = a_perceptronP->Sorties();
		for(int i=0;i<retour.Dim();i++)
		{
			retour(i) = (retour(i) / a_echelle[1](i,i)) + a_translation[1](i);
		}
		return true;
	}
	return false;
}

LRESULT CReseauxDlg::OnKickIdle(WPARAM, LPARAM)
{
	UpdateDialogControls(this, FALSE);
    return 0L;
}

void CReseauxDlg::OnUpdateCommandId(CCmdUI * pCmdUI)
{
	switch(pCmdUI->m_nID)
	{
	case IDC_TESTER:
		pCmdUI->Enable(a_entrainer);
		break;
	case IDC_ECRIREPOIDS:
		pCmdUI->Enable(a_entrainer);
		break;
	case IDC_ENTRAINER:
		pCmdUI->Enable(a_selectEntrFile);
		break;
	}
}

void CReseauxDlg::OnSaveparam() 
{
	CString fileName;
	ofstream output;
	UpdateData(true);
	if(BrowseFile(false,"Fichier de paramtres (*.prm)|*.prm||", fileName))
	{
		output.open(fileName, ios::out);
		output << "Gain=" << a_gain << endl;
		output << "Momentum=" << a_momentum << endl;
		output << "Epsilon=" << a_epsilon << endl;
		output << "Tolerance=" << a_tolerance << endl;
		output << "ErreurMax=" << a_maxErreur << endl;
		output << "IterMax=" << a_maxIter << endl;
		output << "NeuroneEntree=" << a_entree << endl;
		output << "NeuroneSortie=" << a_sortie << endl;
		output << "CoucheCache=" << a_coucheCache << endl;
		output << "NeuroneCoucheCache=" << a_neuroneCC << endl;
		output << "MinOutput=" << a_minOut << endl;
		output << "MaxOutput=" << a_maxOut << endl;
		output << "DonnesTest1=" << a_indata[0] << endl;
		output << "DonnesTest2=" << a_indata[1] << endl;
		output << "DonnesTest3=" << a_indata[2] << endl;
	}
}

void CReseauxDlg::OnOpenparam() 
{
	CString fileName;
	CString buffer;
	CStdioFile input;
	int i;
	if(BrowseFile(true,"Fichier de paramtres (*.prm)|*.prm||", fileName))
	{
		input.Open(fileName, CFile::modeRead | CFile::typeText);
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_gain = atof(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_momentum = atof(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_epsilon = atof(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_tolerance = atof(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_maxErreur = atof(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_maxIter = atoi(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_entree = atoi(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_sortie = atoi(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_coucheCache = atoi(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_neuroneCC = atoi(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_minOut = atof(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_maxOut = atof(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_indata[0] = atof(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_indata[1] = atof(buffer.Mid(i+1));
		input.ReadString( buffer );
		i = buffer.Find('=');
		a_indata[2] = atof(buffer.Mid(i+1));
		UpdateData(false);
	}
}

void CReseauxDlg::OnChangeNeurone() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	a_modifiedNeurone = true;	
}


