// ReseauxDlg.h : header file
//

#if !defined(AFX_RESEAUXDLG_H__A4C71F16_86ED_11D2_B90D_00A0C9F12A22__INCLUDED_)
#define AFX_RESEAUXDLG_H__A4C71F16_86ED_11D2_B90D_00A0C9F12A22__INCLUDED_

#include "Perceptron.hpp"	// Added by ClassView
#include "ubidoc.h"
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CReseauxDlg dialog

class CReseauxDlg : public CDialog
{
// Construction
public:
	void LirePoids(CString fileName);
	 ~CReseauxDlg();
	bool TesterReseaux(double t1, double t2, double t3, Vecteur& retour);
	void EntraineReseaux(CString weightFile);
	CReseauxDlg(CWnd* pParent = NULL);	// standard constructor
	

	LRESULT OnKickIdle(WPARAM, LPARAM);

// Dialog Data
	//{{AFX_DATA(CReseauxDlg)
	enum { IDD = IDD_RESEAUX_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CReseauxDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	HICON m_hIcon;
	afx_msg void OnUpdateCommandId(CCmdUI* pCmdUI);
	// Generated message map functions
	//{{AFX_MSG(CReseauxDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSpin(UINT nID, NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBrowse();
	afx_msg void OnEntrainer();
	afx_msg void OnEcrirepoids();
	afx_msg void OnLirepoids();
	afx_msg void OnTester();
	afx_msg void OnSaveparam();
	afx_msg void OnOpenparam();
	afx_msg void OnChangeNeurone();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	double a_indata[3];
	Vecteur a_translation[2];			// Vecteur de translation des entres et sorties (1,2)
	Matrice a_echelle[2];				// Matrice d'chelle des entres et sorties (1,2)
	
	Perceptron* a_perceptronP;
	bool BrowseFile(bool mOpen, CString filtre, CString& pathName);
	bool a_entrainer;
	bool a_selectEntrFile;
	bool a_modifiedNeurone;
	int	a_entree;
	int a_sortie;
	int a_neuroneCC;
	int a_coucheCache;
	int a_maxIter;
	double a_gain;
	double a_momentum;
	double a_epsilon;
	double a_tolerance;
	double a_maxErreur;
	double a_minOut;
	double a_maxOut;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RESEAUXDLG_H__A4C71F16_86ED_11D2_B90D_00A0C9F12A22__INCLUDED_)
