// UBIView.h : interface of the CUBIView class
//
/////////////////////////////////////////////////////////////////////////////

#include "UBIDoc.h"
#include "UBI.h"
#include "reseauxdlg.h"

#if !defined(AFX_UBIVIEW_H__9A9DF038_4EFD_11D2_B01F_941467F95F3F__INCLUDED_)
#define AFX_UBIVIEW_H__9A9DF038_4EFD_11D2_B01F_941467F95F3F__INCLUDED_

#include "MapView.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMapView;
class CUBIApp;

#include "SerialPort.h"	// Added by ClassView
class CUBIView : public CFormView
{

protected: // create from serialization only
	CUBIView();
	DECLARE_DYNCREATE(CUBIView)

public:
	//{{AFX_DATA(CUBIView)
	enum { IDD = IDD_VIEW };
	CButton	m_bouton;
	CProgressCtrl	m_Batterie;
	CEdit	m_speedG;
	CEdit	m_speedD;
	CEdit	m_RX;
	CEdit	m_TX;
	CEdit	m_PosY;
	CEdit	m_PosX;
	CEdit	m_targetY;
	CEdit	m_targetX;
	CComboBox	m_cmd;
	CEdit	m_msg;
	CEdit	m_LCD;
	CEdit	m_posY;
	CEdit	m_posX;
	//}}AFX_DATA

// Attributes
public:
	CUBIDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUBIView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL
	afx_msg int OnMouseActivate( CWnd* pDesktopWnd, UINT nHitTest, UINT message );

// Implementation
public:
	void EcrireEchantillon();
	char lastchar;
	int state;
	void SendData(int vg, int vd, int rot);
	CRect rectangle;
	CUBIApp* appPtr;
	BOOL stop;
	CWinThread* ACthread;
	CWinThread* Simthread;
	CDocument* doc;
	BOOL InitPort();
	void BeginCheminThread();
	LONG OnRX(WPARAM,LPARAM);
	void ShowRX(CString);
	void ShowTX(CString);
	BOOL CopYflag;
	BOOL CopXflag;
	void ShowCopPos();
	void ShowCopSpeed();
	CSerialPort *CPort;
	void ShowTargetPos();
	void Print_LCD();
	void CreateMap();
	CMapView* m_mapView;
	virtual ~CUBIView();
#ifdef _DEBUG
	virtual void AssertValid() const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CUBIView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnButton2();
	afx_msg void OnGrid();
	afx_msg void OnKillfocusX();
	afx_msg void OnButton1();
	afx_msg void OnButton3();
	afx_msg void OnParamComm();
	afx_msg void OnPanic();
	afx_msg void OnButton7();
	afx_msg void OnPlay();
	afx_msg void OnButton4();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnReseaux();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRadioBandit();
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CReseauxDlg	reseaux;

};

#ifndef _DEBUG  // debug version in UBIView.cpp
inline CUBIDoc* CUBIView::GetDocument()
   { return (CUBIDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_UBIVIEW_H__9A9DF038_4EFD_11D2_B01F_941467F95F3F__INCLUDED_)
