// CommDlg.cpp : implementation file
//

///////////////////////////////////////////////////////////
// La classe CommDlg.cpp effectue la gestion de la boite de 
// dialogue IDD_PARAM_COMM
///////////////////////////////////////////////////////////
#include "stdafx.h"
#include "CommDlg.h"
#include <fstream.h>

#define Baud110    110
#define Baud300    300
#define Baud1200   1200
#define Baud2400   2400
#define Baud4800   4800
#define Baud9600   9600
#define Baud19200  19200
#define Baud38400  38400
#define Baud57600  57600
#define Baud115200 115200
#define COM1   1
#define COM2   2
#define COM3   3
#define COM4   4
#define COM5   5
#define COM6   6
#define COM7   7
#define COM8   8
#define COM9   9
#define COM10  10
#define COM11 11
#define COM12 12
#define COM13 13
#define COM14 14
#define COM15 15

/* Parity Codes */

#define NoParity 0
#define OddParity  1
#define EvenParity 2
#define MarkParity 3
#define SpaceParity 4

/* Stop Bit Codes */

#define OneStopBit  0
#define TwoStopBits 2

/* Word Length Codes */

#define WordLength5  5
#define WordLength6  6
#define WordLength7  7
#define WordLength8  8



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CommDlg dialog


CommDlg::CommDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CommDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CommDlg)
	m_baud = -1;
	//}}AFX_DATA_INIT

}


void CommDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CommDlg)
	DDX_Control(pDX, IDC_PORTSELECT, m_portselect);
	DDX_Radio(pDX, IDC_BAUD110, m_baud);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CommDlg, CDialog)
	//{{AFX_MSG_MAP(CommDlg)
	ON_CBN_SELCHANGE(IDC_PORTSELECT, OnSelchangePortselect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CommDlg message handlers

BOOL CommDlg::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	return CDialog::Create(IDD, pParentWnd);
}


///////////////////////////////////////////////////
// Lorsqu'on appuie sur le bouton OK, on sauvegarde 
// les paramtres dans le fichier SCOM.INI
///////////////////////////////////////////////////
void CommDlg::OnOK() 
{
	SavePortSetting();
	/* fermeture du port */
	if(m_hView->InitPort())
		return;
	CDialog::OnOK();
}

////////////////////////////////////////////////////////////////
// OnInitDialog: S'excute juste avant que la boite de dialogue 
//				 soit cr. Il faut setter les cases d'options
//				 juste avant que la boite de dialogue s'affiche
////////////////////////////////////////////////////////////////
BOOL CommDlg::OnInitDialog() 
{
	int id_baud;
	LoadPortSetting();
	CDialog::OnInitDialog();
	
	id_baud = GetBaudID(port1.baud);
	///////////////////////////////////////////////////////
	// La fonction CheckRadioButton coche une case d'option
	// parmi le groupe spcifi
	///////////////////////////////////////////////////////
	CheckRadioButton(IDC_BAUD110,IDC_BAUD38400,id_baud);
	
	/////////////////////////////////////////////////////////////////
	// la variable m_portselect est associ au menu droulant de
	// la boite de dialogue. Dans notre cas, elle slectionne le COM
	// du port dont on affiche la config.
	////////////////////////////////////////////////////////////////
	m_portselect.SetCurSel(last_port);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


///////////////////////////////////////////////////////////////////////////
// OnSelchangePortselect: Cette fonction est appel lorsqu'on slectionnne
//                        un item dans la liste droulante qui permet de 
//						  choisir le COM
///////////////////////////////////////////////////////////////////////////
void CommDlg::OnSelchangePortselect() 
{
	int baud;
	int id;

	// Sauvegarde des paramtres du port prcdant
	baud   = GetCheckedRadioButton(IDC_BAUD110,IDC_BAUD19200);
	switch(baud)
	{
	case IDC_BAUD110: baud = Baud110;
		break;
	case IDC_BAUD300: baud = Baud300;
		break;
	case IDC_BAUD38400: baud = Baud38400;
		break;
	case IDC_BAUD1200: baud = Baud1200;
		break;
	case IDC_BAUD2400: baud = Baud2400;
		break;
	case IDC_BAUD4800: baud = Baud4800;
		break;
	case IDC_BAUD9600: baud = Baud9600;
		break;
	case IDC_BAUD19200: baud = Baud19200;
		break;
	}

	port1.baud = baud;
	
	//rcupration des paramtres pour le port choisi
	last_port = m_portselect.GetCurSel();
	
	switch(baud)
	{
	case Baud110: id = IDC_BAUD110;
		break;
	case Baud300: id = IDC_BAUD300;	
		break;
	case Baud38400: id = IDC_BAUD38400;
		break;
	case Baud1200: id = IDC_BAUD1200;
		break;
	case Baud2400: id = IDC_BAUD2400;
		break;
	case Baud4800: id = IDC_BAUD4800;
		break;
	case Baud9600: id = IDC_BAUD9600;	
		break;
	case Baud19200: id = IDC_BAUD19200;
		break;
	}
	//Configuration du baud rate	
	CheckRadioButton(IDC_BAUD110,IDC_BAUD38400,id);
	}

/////////////////////////////////////////////////////////////////////
// LoadPortSetting: Lecture de la config dans le fichier SCOM.INI
/////////////////////////////////////////////////////////////////////
void CommDlg::LoadPortSetting()
{
	int empty = TRUE;
	char buf[100];
	ifstream INIfile("scom.ini",ios::in);

	while(!INIfile.eof()){
	
		INIfile.getline(buf,100);

		// LECTURE DES OPTIONS ET ASSIGNEMENT 
		if(strcmp(buf,"[OPTIONS]") == 0) 
		{	
			empty = FALSE;
			INIfile.getline(buf,100);
			last_port = GetParam(buf) -1;
		}

		// PARAMETRE DU PREMIER PORT
		if(strcmp(buf,"[Port#1]") == 0) 
		{
			INIfile.getline(buf,100);
			port1.baud = GetParam(buf);
		}	
	}
	if(empty)
	{
		last_port = 1;
		port1.baud = 0;
	}
	INIfile.close();

}

/////////////////////////////////////////////////////////////////
// SavePortSetting: Sauvegarde la config dans le fichier SCOM.INI
/////////////////////////////////////////////////////////////////
void CommDlg::SavePortSetting()
{
	int last_port,baud;
	last_port = m_portselect.GetCurSel()+1;
	baud   = GetCheckedRadioButton(IDC_BAUD110,IDC_BAUD38400);
	switch(baud)
	{
	case IDC_BAUD110: baud = Baud110;
		break;
	case IDC_BAUD300: baud = Baud300;
		break;
	case IDC_BAUD38400: baud = Baud38400;
		break;
	case IDC_BAUD1200: baud = Baud1200;
		break;
	case IDC_BAUD2400: baud = Baud2400;
		break;
	case IDC_BAUD4800: baud = Baud4800;
		break;
	case IDC_BAUD9600: baud = Baud9600;
		break;
	case IDC_BAUD19200: baud = Baud19200;
		break;
	}

	port1.baud = baud;

	ofstream INIfile("scom.ini",ios::out);
	INIfile<<";scom.ini"<<endl;
	INIfile<<";fichier de configuration des ports sries"<<endl<<endl;
	INIfile<<"[OPTIONS]"<<endl;
	INIfile<<"Last Port = "<<last_port<<endl;

	INIfile<<endl<<"[Port#1]"<<endl;
	INIfile<<"Baud Rate = "<<port1.baud<<endl;
	INIfile.close();
}


////////////////////////////////////////////////////////////
// OnCancel: Lorsqu'on appuie sur le bouton Cancel, 
//           on ferme la boite de dialogue sans sauvegarder
//			 les paramtres.
////////////////////////////////////////////////////////////
void CommDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	CDialog::OnCancel();
}

//////////////////////////////////////////////
// Dcode les paramtres du fichier scom.ini 
// ex: parity = 0; GetParam() retourne 0;   
//////////////////////////////////////////////
int CommDlg::GetParam(char *buf)
{
	int value = 0;
	int chiffre;
	unsigned int j= 0;
	while(buf[j] != '=' && j <= sizeof(buf))
		j++;

	j++;
	while(j < strlen(buf))
	{
		chiffre = 0;
		if(buf[j] == ' ')
			chiffre = 10;
		if(buf[j] == '0')
			chiffre = 0;
		if(buf[j] == '1')
			chiffre = 1;
		if(buf[j] == '2')
			chiffre = 2;
		if(buf[j] == '3')
			chiffre = 3;
		if(buf[j] == '4')
			chiffre = 4;
		if(buf[j] == '5')
			chiffre = 5;
		if(buf[j] == '6')
			chiffre = 6;
		if(buf[j] == '7')
			chiffre = 7;
		if(buf[j] == '8')
			chiffre = 8;
		if(buf[j] == '9')
			chiffre = 9;
		if(chiffre != 10)
			value = value*10 + chiffre;
		j++;
	}
	return value;
}


///////////////////////////////////////////////////
// Les fonctions qui suivent un paramtre de config
// et retourne un ID(dfini dans wsc.h) qui est le
// standard utiliser le DLL de gestion du port srie
// Wsc32.dll  
///////////////////////////////////////////////////
int CommDlg::GetBaudID(int baud)
{
	switch(baud)
	{
	case Baud110: 
		return IDC_BAUD110;
		break;
	case Baud38400:
		return IDC_BAUD38400;
		break;
	case Baud300: 
		return IDC_BAUD300;
		break;
	case Baud1200:
		return IDC_BAUD1200;
		break;
	case Baud2400:
		return IDC_BAUD2400;
		break;
	case Baud4800:
		return IDC_BAUD4800;
		break;
	case Baud9600:
		return IDC_BAUD9600;
		break;
	case Baud19200:
		return IDC_BAUD19200;
		break;
	default: return IDC_BAUD9600; 
	}
}


int CommDlg::GetParityID(int parity)
{
	switch(parity)
	{
	case 0: return IDC_PARITY_NONE;
		break;
	case 1: return IDC_PARITY_EVEN;
		break;
	case 2: return IDC_PARITY_ODD;
		break;
	default: return 0;
	}
}

int CommDlg::GetStopBitID(int stop)
{
	switch(stop)
	{
	case 0: return IDC_STOPBIT0;
		break;
	case 1: return IDC_STOPBIT1;
		break;
	case 2: return IDC_STOPBIT2;
		break;
	default: return 0;
	}
}

