// MapView.cpp : implementation file
//

#include "stdafx.h"
#include "ubi.h"
#include "MapView.h"
#include "global.h"
#include "chemin.cpp"

#define IDC_BANDIT 666

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapView

IMPLEMENT_DYNCREATE(CMapView, CView)

CMapView::CMapView()
{
}

CMapView::~CMapView()
{
}


BEGIN_MESSAGE_MAP(CMapView, CView)
	//{{AFX_MSG_MAP(CMapView)
	ON_WM_CREATE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_CANCELMODE()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMapView diagnostics

#ifdef _DEBUG
void CMapView::AssertValid() const
{
	CView::AssertValid();
}

void CMapView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMapView message handlers
void CMapView::ShowMap()
{
	CDC dc;
	CDC* pDC;
	CBitmap bmp;
	CBitmap *oldBMP;
	CDocument* pDoc = GetDocument();
	CRect rect;
	///////////////////////////////////////
	// Affichage du fond blanc
	GetClientRect(&rect);
	pDC = GetDC();
	ASSERT(pDC != NULL);
	bmp.CreateCompatibleBitmap(pDC, 500, 500);
	dc.CreateCompatibleDC(pDC);
	
	oldBMP = dc.SelectObject(&bmp);

	dc.SelectStockObject(WHITE_BRUSH);
	dc.Rectangle(rect);
	DrawSquare(&dc);
	if(grid == TRUE)
	{
		ShowGrid(&dc);
	}
	ShowTarget(&dc);
	ShowPath(&dc);
	ShowCop(&dc);
	if(bandit_flag)
		ShowBandit(&dc);
	///////////////////////////////////////////
	// On swap les DC
	pDC->BitBlt(0,0,500,500,&dc,0,0,SRCCOPY);
	ReleaseDC(pDC);
	dc.SelectObject(oldBMP);
}

void CMapView::ShowTarget(CDC *memdc)
{
	int tx, ty;
	CPen* oldPen;
	CPen pen(PS_SOLID, 1, 0x0000ff);
	CPoint pt;
	if(Target.x > -1 && Target.y > -1)
	{
		pt.x = Target.x - Target.x%(500/dimension) + (500/dimension)/2;
		pt.y = Target.y - Target.y%(500/dimension) + (500/dimension)/2;
		Target.x = pt.x;
		Target.y = pt.y;
	}
	////////////////////////////////////////
	// Affichage du target
	if(!(Target.y < 0 || Target.y > 500 || Target.y < 0 || Target.y > 500))
	{
		oldPen = memdc->SelectObject(&pen);
		memdc->SelectStockObject(WHITE_BRUSH);
		memdc->Ellipse(Target.x-14, Target.y+14, Target.x+14, Target.y-14);
		memdc->Ellipse(Target.x-10, Target.y+10, Target.x+10, Target.y-10);
		memdc->MoveTo(Target.x, Target.y + 18);
		memdc->LineTo(Target.x, Target.y - 18);
		memdc->MoveTo(Target.x-18, Target.y);
		memdc->LineTo(Target.x+18, Target.y);
		memdc->Ellipse(Target.x-6, Target.y+6, Target.x+6, Target.y-6);
		memdc->SelectStockObject(BLACK_BRUSH);
		memdc->Ellipse(Target.x-3, Target.y+3, Target.x+3, Target.y-3);
		memdc->SelectObject(oldPen);
		pen.DeleteObject();
}
}

int CMapView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{

	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO: Add your specialized creation code here
	if(firstView)
	{
		Cop.x = 25;
		Cop.y = 25;
		Sem_Position.Lock();
		m_Robot_Pre_X = Cop.x;
		m_Robot_Pre_Y = Cop.y;
		// Position dans la matrice
		Robot_X = (Cop.x - (Cop.x%(500/dimension)))/(500/dimension);
		Robot_Y = (Cop.y - (Cop.y%(500/dimension)))/(500/dimension);
		Sem_Position.Unlock();
		Sem_Arrive.Lock();
		Robot_Arrive_X = Robot_X;
		Robot_Arrive_Y = Robot_Y;
		Sem_Arrive.Unlock();
		target_flag = FALSE;
		obstacle_flag = FALSE;
		grid = FALSE;
		for(int a = 0; a < dimension + 1; a++)
			for(int b = 0; b < dimension + 1; b++)
				Map[a][b] = 0;
		Target.x = -25;
		Target.y = -25;
		for(int i=0;i<dimension+2;i++)		//1 : obstcle virtuel
		{									
			Map[i][0]=1;
			Map[i][dimension+1]=1;
			Map[0][i]=1;
			Map[dimension+1][i]=1;
		}
		for(i=0;i<dimension;i++)		//1 : obstcle virtuel
		{									
			Map[i+1][1]=2;
			Map[i+1][dimension]=2;
			Map[1][i+1]=2;
			Map[dimension][i+1]=2;
		}

		firstView = FALSE;
		
	}
	return 0;
}

void CMapView::OnDraw(CDC* pDC) 
{
	ShowMap();
}


void CMapView::DrawSquare(CDC *memdc)
{
	int a, c;
	CPoint pt;
	CPen* oldpen;
	CBrush* oldbrush;
	memdc->SelectStockObject(BLACK_BRUSH);
	for(a = 1; a < dimension+1; a++)
		for(c = 1; c < dimension+1; c++) 
		{
			if(Map[a][c]==1)
			{
				pt.x = (c-1)*(500/dimension);
				pt.y = (a-1)*(500/dimension);
				memdc->Rectangle(pt.x, pt.y, pt.x+(500/dimension), pt.y+(500/dimension));
			
			}
		}
	
	CBrush Overscan(HS_BDIAGONAL,0x8e8e8e);
	oldbrush = memdc->SelectObject(&Overscan);
	CPen pen(PS_SOLID, 1, 0x8e8e8e);
	oldpen = memdc->SelectObject(&pen);
	for(a = 1; a < dimension+1; a++)
		for(c = 1; c < dimension+1; c++) 
		{
			if(Map[a][c]==2)
			{
				pt.x = (c-1)*(500/dimension);
				pt.y = (a-1)*(500/dimension);
				memdc->Rectangle(pt.x, pt.y, pt.x+(500/dimension), pt.y+(500/dimension));
			}
		}
	//Obstacle physique
	CBrush Overs(HS_DIAGCROSS,0x00ff00);
	memdc->SelectObject(Overs);
	CPen pen2(PS_SOLID, 1, 0x00ff00);
	memdc->SelectObject(pen2);

	for(a = 1; a < dimension+1; a++)
		for(c = 1; c < dimension+1; c++) 
		{
			if(Map[a][c]==3)
			{
				pt.x = (c-1)*(500/dimension);
				pt.y = (a-1)*(500/dimension);
				memdc->Rectangle(pt.x, pt.y, pt.x+(500/dimension), pt.y+(500/dimension));
			}
		}
	memdc->SelectStockObject(BLACK_PEN);
	memdc->MoveTo(0,0);
	memdc->LineTo(0,501);
	memdc->MoveTo(0,501);
	memdc->LineTo(502,501);
	memdc->MoveTo(502,501);
	memdc->LineTo(501,0);
	memdc->MoveTo(501,0);
	memdc->LineTo(0,0);
	Overscan.DeleteObject();
	Overs.DeleteObject();
	pen2.DeleteObject();
	pen.DeleteObject();
	memdc->SelectObject(oldpen);
	memdc->SelectObject(oldbrush);
}

void CMapView::ShowGrid(CDC *memdc)
{
	int x;
	memdc->SelectStockObject(BLACK_PEN);
	for(x = 500/dimension; x < 500; x += 500/dimension)
	{
		memdc->MoveTo(x,0);
		memdc->LineTo(x,500);
		memdc->MoveTo(0,x);
		memdc->LineTo(500,x);
	}
	grid = TRUE;
}

void CMapView::ShowCop(CDC *memdc)
{
	CBitmap ubicop;
	CBitmap *oldBitmap;
	CPoint pt;
	pt.x = Cop.x - Cop.x%(500/dimension) + (500/dimension)/2 - 10;
	pt.y = Cop.y - Cop.y%(500/dimension) + (500/dimension)/2 - 10;
	switch(m_Dir_Pas-1)
	{
	case 1:
		ubicop.LoadBitmap(IDB_UBICOP_45);
		break;
	case 2:
		ubicop.LoadBitmap(IDB_UBICOP_90);
		break;
	case 3:
		ubicop.LoadBitmap(IDB_UBICOP_135);
		break;
	case 4:
		ubicop.LoadBitmap(IDB_UBICOP_180);
		break;
	case 5:
		ubicop.LoadBitmap(IDB_UBICOP_225);
		break;
	case 6:
		ubicop.LoadBitmap(IDB_UBICOP_270);
		break;
	case 7:
		ubicop.LoadBitmap(IDB_UBICOP_315);
		break;
	default:
		ubicop.LoadBitmap(IDB_UBICOP_0);
		break;
	}
	CDC mDC;
	mDC.CreateCompatibleDC(memdc);
	oldBitmap = mDC.SelectObject(&ubicop);
	memdc->BitBlt(pt.x,pt.y,20,20,&mDC,0,0,SRCCOPY);
	mDC.SelectObject(oldBitmap);
	ubicop.DeleteObject();
	m_ubiView->ShowCopPos();
}

void CMapView::ShowBandit(CDC *memdc)
{
	CBitmap* oldBitmap;
	CBitmap bandit;
	CPoint pot;
	pot.x = Bandit.x - Bandit.x%(500/dimension) + (500/dimension)/2 - 10;
	pot.y = Bandit.y - Bandit.y%(500/dimension) + (500/dimension)/2 - 10;
	switch(Bandit_dir)
	{
	case 1:
		bandit.LoadBitmap(IDB_BANDIT1);
		break;
	case 2:
		bandit.LoadBitmap(IDB_BANDIT2);
		break;
	case 3:
		bandit.LoadBitmap(IDB_BANDIT3);
		break;
	case 4:
		bandit.LoadBitmap(IDB_BANDIT4);
		break;
	case 5:
		bandit.LoadBitmap(IDB_BANDIT5);
		break;
	case 6:
		bandit.LoadBitmap(IDB_BANDIT6);
		break;
	case 7:
		bandit.LoadBitmap(IDB_BANDIT9);
		break;
	case 8:
		bandit.LoadBitmap(IDB_BANDIT10);
		break;
	default:
		bandit.LoadBitmap(IDB_BANDIT1);
		break;
	}
	CDC sDC;
	sDC.CreateCompatibleDC(memdc);
	//mDC->SelectStockObject(WHITE_BRUSH);
	oldBitmap = (CBitmap*)sDC.SelectObject(&bandit);	
	memdc->BitBlt(pot.x,pot.y,20,20,&sDC,0,0,SRCCOPY);
	sDC.SelectObject(oldBitmap);
	bandit.DeleteObject();
}

void CMapView::OnMouseMove(UINT nFlags, CPoint point) 
{
	int x, y;
	x = (point.x - (point.x%(500/dimension)))/(500/dimension) + 1;
	y = (point.y - (point.y%(500/dimension)))/(500/dimension) + 1;
	int sel = -1;
	sel = m_ubiView->GetCheckedRadioButton(IDC_RADIO_TARGET,IDC_RADIO_BANDIT);
	if(nFlags)
		switch(sel)
		{
			case IDC_RADIO_START:
				{
					Cop = point;
					Sem_Position.Lock();
					m_Robot_Pre_X = Cop.x;
					m_Robot_Pre_Y = Cop.y;
					// Position dans la matrice
					Robot_X = (Cop.x - (Cop.x%(500/dimension)))/(500/dimension);
					Robot_Y = (Cop.y - (Cop.y%(500/dimension)))/(500/dimension);
					Sem_Position.Unlock();
					m_ubiView->ShowCopPos();
					ShowMap();
				}
				break;
			case IDC_RADIO_BANDIT:
				{
					Bandit = point;
					bandit_flag = TRUE;
					ShowMap();
				}
				break;
			case IDC_RADIO_OBSTACLE:
				{
					obstacle_flag = TRUE;
					if(nFlags == MK_LBUTTON)
					{
						if(Map[y][x]==0 || Map[y][x]==2)
						{
						Map[y][x] = 1;
						if(Map[y-1][x-1]==0)
							Map[y-1][x-1]=2;
						if(Map[y-1][x]==0)
							Map[y-1][x]=2;
						if(Map[y-1][x+1]==0)
							Map[y-1][x+1]=2;
						if(Map[y][x-1]==0)
							Map[y][x-1]=2;
						if(Map[y][x]==0)
							Map[y][x]=2;
						if(Map[y][x+1]==0)
							Map[y][x+1]=2;
						if(Map[y+1][x-1]==0)
							Map[y+1][x-1]=2;
						if(Map[y+1][x]==0)
							Map[y+1][x]=2;
						if(Map[y+1][x+1]==0)
							Map[y+1][x+1]=2;
}
					}
					if(nFlags == MK_RBUTTON)
						EffaceSquare(point);
				ShowMap();
				}
				break;
			case IDC_RADIO_TARGET:
				{
					target_flag = TRUE;
					Target = point;
					Sem_Arrive.Lock();
					// Position dans la matrice
					Robot_Arrive_X = (Target.x - (Target.x%(500/dimension)))/(500/dimension);
					Robot_Arrive_Y = (Target.y - (Target.y%(500/dimension)))/(500/dimension);
					Sem_Arrive.Unlock();
					m_ubiView->ShowTargetPos();
					ShowMap();
				}
				break;
			default:
				break;
		}				
	CView::OnMouseMove(nFlags, point);
}

void CMapView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int sel = -1;
	int x = (point.x - (point.x%(500/dimension)))/(500/dimension) + 1;
	int y = (point.y - (point.y%(500/dimension)))/(500/dimension) + 1;
	sel = m_ubiView->GetCheckedRadioButton(IDC_RADIO_TARGET,IDC_RADIO_BANDIT);
	switch(sel)
	{
		case IDC_RADIO_BANDIT:
			{
				Bandit = point;
				bandit_flag = TRUE;
				ShowMap();
			}
			break;
		case IDC_RADIO_START:
			{
			Cop = point;
			Sem_Position.Lock();
			m_Robot_Pre_X = Cop.x;
			m_Robot_Pre_Y = Cop.y;
			// Position dans la matrice
			Robot_X = (Cop.x - (Cop.x%(500/dimension)))/(500/dimension);
			Robot_Y = (Cop.y - (Cop.y%(500/dimension)))/(500/dimension);
			Sem_Position.Unlock();
			m_ubiView->ShowCopPos();
			ShowMap();
			}
			break;
		case IDC_RADIO_TARGET:
			{
			Target = point;
			target_flag = TRUE;
			Sem_Arrive.Lock();
			// Position dans la matrice
			Robot_Arrive_X = (Target.x - (Target.x%(500/dimension)))/(500/dimension);
			Robot_Arrive_Y = (Target.y - (Target.y%(500/dimension)))/(500/dimension);
			Sem_Arrive.Unlock();
			m_ubiView->ShowTargetPos();
			ShowMap();
			}
			break;
		case IDC_RADIO_OBSTACLE:
			{
			obstacle_flag = TRUE;
			if(Map[y][x]==0||Map[y][x]==2)
				{
				Map[y][x] = 1;
				if(Map[y-1][x-1]==0)
					Map[y-1][x-1]=2;
				if(Map[y-1][x]==0)
					Map[y-1][x]=2;
				if(Map[y-1][x+1]==0)
					Map[y-1][x+1]=2;
				if(Map[y][x-1]==0)
					Map[y][x-1]=2;
				if(Map[y][x]==0)
					Map[y][x]=2;
				if(Map[y][x+1]==0)
					Map[y][x+1]=2;
				if(Map[y+1][x-1]==0)
					Map[y+1][x-1]=2;
				if(Map[y+1][x]==0)
					Map[y+1][x]=2;
				if(Map[y+1][x+1]==0)
					Map[y+1][x+1]=2;
				}
			ShowMap();
			}
			break;
		default:
			break;
	}				
	CView::OnLButtonDown(nFlags, point);
}

void CMapView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	int sel = -1;
	int x = (point.x - (point.x%(500/dimension)))/(500/dimension) + 1;
	int y = (point.y - (point.y%(500/dimension)))/(500/dimension) + 1;
	sel = m_ubiView->GetCheckedRadioButton(IDC_RADIO_TARGET,IDC_RADIO_START);
	switch(sel)
	{
	case IDC_RADIO_OBSTACLE:
		{
			obstacle_flag = TRUE;
			EffaceSquare(point);
			ShowMap();
		}
		break;
	default:
		break;
	}				
	CView::OnRButtonDown(nFlags, point);
}

void CMapView::ShowPath(CDC *memdc)
{
	Point Temp_Point;
	CPoint pt1, pt2;
	CPoint t1, t2;
	CPen* oldpen;
	CPen pen(PS_SOLID, 1, 0x0000ff); // crayon rouge
	Sem_Liste.Lock();
	int i = Robot_Chemin.NbElements();
	oldpen = memdc->SelectObject(&pen);
	// ramener les coordonnes du robot au carreau
	pt1.x = (Cop.x - Cop.x%(500/dimension));
	pt1.y = (Cop.y - Cop.y%(500/dimension));
	while(i)
	{
		Temp_Point = Robot_Chemin[i-1];
		--Robot_Chemin;
		pt2.x = Temp_Point.X*(500/dimension);
		pt2.y = Temp_Point.Y*(500/dimension);
		memdc->MoveTo(pt1.x+ (250/dimension), pt1.y+ (250/dimension));
		memdc->LineTo(pt2.x+ (250/dimension), pt2.y+ (250/dimension));
		pt1 = pt2;
		i--;
	}
	Sem_Liste.Unlock();
	memdc->SelectObject(oldpen);
	pen.DeleteObject();
}

void CMapView::EffaceSquare(CPoint point)
{
	int x = (point.x - (point.x%(500/dimension)))/(500/dimension) + 1;
	int y = (point.y - (point.y%(500/dimension)))/(500/dimension) + 1;

	if(Map[y][x]==1)
	{
		if((Map[y-1][x-1]==2||Map[y-1][x-1]==0)
			&&(Map[y-1][x]==2||Map[y-1][x]==0)
			&&(Map[y-1][x+1]==2||Map[y-1][x+1]==0)
			&&(Map[y][x+1]==2||Map[y][x+1]==0)
			&&(Map[y+1][x+1]==2||Map[y+1][x+1]==0)
			&&(Map[y+1][x]==2||Map[y+1][x]==0)
			&&(Map[y+1][x-1]==2||Map[y+1][x-1]==0)
			&&(Map[y][x-1]==2||Map[y][x-1]==0))
		{			
			Map[y][x] = 0;
		}
		else
		{
			Map[y][x] = 2;
		}

		if(Map[y-1][x-1]==2)
		{
			if((Map[y][x-1]==2||Map[y][x-1]==0)
				&&(Map[y][x-2]==2||Map[y][x-2]==0)
				&&(Map[y-1][x-2]==2||Map[y-1][x-2]==0)
				&&(Map[y-2][x-2]==2||Map[y-2][x-2]==0)
				&&(Map[y-2][x-1]==2||Map[y-2][x-1]==0)
				&&(Map[y-2][x]==2||Map[y-2][x]==0)
				&&(Map[y-1][x]==2||Map[y-1][x]==0))
			{
				Map[y-1][x-1]=0;
			}

		}

		if(Map[y-1][x]==2)
		{
			if((Map[y][x-1]==2||Map[y][x-1]==0)
				&&(Map[y-1][x-1]==2||Map[y-1][x-1]==0)
				&&(Map[y-2][x-1]==2||Map[y-2][x-1]==0)
				&&(Map[y-2][x]==2||Map[y-2][x]==0)
				&&(Map[y-2][x+1]==2||Map[y-2][x+1]==0)
				&&(Map[y-1][x+1]==2||Map[y-1][x+1]==0)
				&&(Map[y][x+1]==2||Map[y][x+1]==0))
			{
				Map[y-1][x]=0;
			}
		}
		
		if(Map[y-1][x+1]==2)
		{
			if((Map[y-1][x]==2||Map[y-1][x]==0)
				&&(Map[y-2][x]==2||Map[y-2][x]==0)
				&&(Map[y-2][x+1]==2||Map[y-2][x+1]==0)
				&&(Map[y-2][x+2]==2||Map[y-2][x+2]==0)
				&&(Map[y-1][x+2]==2||Map[y-1][x+2]==0)
				&&(Map[y][x+2]==2||Map[y][x+2]==0)
				&&(Map[y][x+1]==2||Map[y][x+1]==0))
			{
				Map[y-1][x+1]=0;
			}
		}

		if(Map[y][x+1]==2)
		{
			if((Map[y-1][x]==2||Map[y-1][x]==0)
				&&(Map[y-1][x+1]==2||Map[y-1][x+1]==0)
				&&(Map[y-1][x+2]==2||Map[y-1][x+2]==0)
				&&(Map[y][x+2]==2||Map[y][x+2]==0)
				&&(Map[y+1][x+2]==2||Map[y+1][x+2]==0)
				&&(Map[y+1][x+1]==2||Map[y+1][x+1]==0)
				&&(Map[y+1][x]==2||Map[y+1][x]==0))
			{
				Map[y][x+1]=0;
			}
		}

		if(Map[y+1][x+1]==2)
		{
			if((Map[y][x+1]==2||Map[y][x+1]==0)
				&&(Map[y][x+2]==2||Map[y][x+2]==0)
				&&(Map[y+1][x+2]==2||Map[y+1][x+2]==0)
				&&(Map[y+2][x+2]==2||Map[y+2][x+2]==0)
				&&(Map[y+2][x+1]==2||Map[y+2][x+1]==0)
				&&(Map[y+2][x]==2||Map[y+2][x]==0)
				&&(Map[y+1][x]==2||Map[y+1][x]==0))
			{
				Map[y+1][x+1]=0;
			}
		}

		if(Map[y+1][x]==2)
		{
			if((Map[y][x+1]==2||Map[y][x+1]==0)
				&&(Map[y+1][x+1]==2||Map[y+1][x+1]==0)
				&&(Map[y+2][x+1]==2||Map[y+2][x+1]==0)
				&&(Map[y+2][x]==2||Map[y+2][x]==0)
				&&(Map[y+2][x-1]==2||Map[y+2][x-1]==0)
				&&(Map[y+1][x-1]==2||Map[y+1][x-1]==0)
				&&(Map[y][x-1]==2||Map[y][x-1]==0))
			{
				Map[y+1][x]=0;
			}
		}

		if(Map[y+1][x-1]==2)
		{
			if((Map[y+1][x]==2||Map[y+1][x]==0)
				&&(Map[y+2][x]==2||Map[y+2][x]==0)
				&&(Map[y+2][x-1]==2||Map[y+2][x-1]==0)
				&&(Map[y+2][x-2]==2||Map[y+2][x-2]==0)
				&&(Map[y+1][x-2]==2||Map[y+1][x-2]==0)
				&&(Map[y][x-2]==2||Map[y][x-2]==0)
				&&(Map[y][x-1]==2||Map[y][x-1]==0))
			{
				Map[y+1][x-1]=0;
			}
		}

		if(Map[y][x-1]==2)
		{
			if((Map[y+1][x]==2||Map[y+1][x]==0)
				&&(Map[y+1][x-1]==2||Map[y+1][x-1]==0)
				&&(Map[y+1][x-2]==2||Map[y+1][x-2]==0)
				&&(Map[y][x-2]==2||Map[y][x-2]==0)
				&&(Map[y-1][x-2]==2||Map[y-1][x-2]==0)
				&&(Map[y-1][x-1]==2||Map[y-1][x-1]==0)
				&&(Map[y-1][x]==2||Map[y-1][x]==0))
			{
				Map[y][x-1]=0;
			}
		}


	}

}



void CMapView::Reset_Obstacle_Virt()
{
	//Enlve les obstacles virtuelles..
	int i,j;
	CPoint Pos;

		for(i=1;i<dimension+1;i++)		
		{
			for(j=1;j<dimension+1;j++)
			{
				if(Map[i][j]==1)
					{
					Pos.x = (j*(500/dimension))-1;
					Pos.y = (i*(500/dimension))-1;
					EffaceSquare(Pos);
					}
			}
		}
	ShowMap();

}

void CMapView::Reset_Obstacle_Reel()
{
	//Enlve les obstacles virtuelles..
	int i,j;
	CPoint Pos;

		for(i=1;i<dimension+1;i++)		
		{
			for(j=1;j<dimension+1;j++)
			{
				if(Map[i][j]==3)
					Efface_Obstacle(i,j);
			}
		}
	ShowMap();

}

