// UBIView.cpp : implementation of the CUBIView class
//

#include "stdafx.h"
#include "UBI.h"
#include "MapView.h"

#include "UBIDoc.h"
#include "UBIView.h"
#include "port.h"
#include "CommDlg.h"
#include <string.h>

int delai;
int compteur1 = 0;
int compteur2 = 0;
extern float donnee[3];
extern rayon;
extern int Robot_Rotation;
extern BOOL rotation_flag;
extern void Update_MAP(int Infra_Droite, int Infra_Gauche);
extern long delais (short bipa , short bipb , int overflow);
extern short delai1, delai2, delai3, delai4;
extern int Bandit_dir;
#define WM_INIT_PORT	115132
extern BOOL firstView;
extern CPoint Target;
extern int grid;
extern UINT Algo_Chemin(LPVOID pParam);
extern UINT Simulation(LPVOID);
extern void Initialisation();
int COM1 = 1;
extern BOOL simflag;
extern CMapView* cMap;
extern BOOL Online;
extern CUBIApp theApp;
int px, py;

#define dimension 20
#define UBI_POS 1
#define UBI_OBSTACLE 2


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern m_Dir_Pas;
extern m_Dir_Pre;
extern int grid;	// Quadrillage(1 = oui, 0 = Non) 
extern CPoint Cop;	// La position du robot
extern CPoint Bandit;
extern CSemaphore Sem_Position;
extern CSemaphore Sem_Vitesse;
extern double m_Robot_Pre_X;
extern double m_Robot_Pre_Y;
extern int Robot_Vitesse_G;
extern int Robot_Vitesse_D;
extern int Robot_Y;
extern int Robot_X;
extern BOOL Online;


/////////////////////////////////////////////////////////////////////////////
// CUBIView

IMPLEMENT_DYNCREATE(CUBIView, CFormView)

BEGIN_MESSAGE_MAP(CUBIView, CFormView)
	//{{AFX_MSG_MAP(CUBIView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_COMMAND(ID_GRID, OnGrid)
	ON_EN_KILLFOCUS(IDC_X, OnKillfocusX)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_COMMAND(ID_PARAM_COMM, OnParamComm)
	ON_BN_CLICKED(IDC_PANIC, OnPanic)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDB_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RESEAUX, OnReseaux)
	ON_WM_KEYDOWN()
	ON_BN_CLICKED(IDC_RADIO_BANDIT, OnRadioBandit)
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	ON_WM_MOUSEACTIVATE()
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_MESSAGE(WM_COMM_RXCHAR, OnRX)
	ON_MESSAGE(WM_INIT_PORT, InitPort)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUBIView construction/destruction

CUBIView::CUBIView()
	: CFormView(CUBIView::IDD),
	  reseaux(this)
{
  AfxMessageBox("Choisissez un fichier de poids pour le rseau de neurones", MB_OK);
  reseaux.OnLirepoids();
  //reseaux.LirePoids("c:\\robot\\poids\\poids1.wgh");
}  

CUBIView::~CUBIView()
{
	if(CPort->m_bThreadAlive)
	{
		CPort->StopMonitoring();
		delete CPort;
	}	
}

BOOL CUBIView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CUBIView drawing

void CUBIView::OnDraw(CDC* pDC)
{
}

/////////////////////////////////////////////////////////////////////////////
// CUBIView printing

BOOL CUBIView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CUBIView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CUBIView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// CUBIView diagnostics

#ifdef _DEBUG
void CUBIView::AssertValid() const
{
	CFormView::AssertValid();
}


CUBIDoc* CUBIView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CUBIDoc)));
	return (CUBIDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CUBIView message handlers

void CUBIView::DoDataExchange(CDataExchange* pDX) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUBIView)
	DDX_Control(pDX, IDC_BUTTON2, m_bouton);
	DDX_Control(pDX, IDC_BATTERIE, m_Batterie);
	DDX_Control(pDX, IDC_SPEEDG, m_speedG);
	DDX_Control(pDX, IDC_SPEEDD, m_speedD);
	DDX_Control(pDX, IDC_RX, m_RX);
	DDX_Control(pDX, IDC_TX, m_TX);
	DDX_Control(pDX, IDC_Y, m_PosY);
	DDX_Control(pDX, IDC_X, m_PosX);
	DDX_Control(pDX, IDC_TARGETY, m_targetY);
	DDX_Control(pDX, IDC_TARGETX, m_targetX);
	//}}AFX_DATA_MAP
   
}



void CUBIView::CreateMap()
{
	m_mapView = new CMapView;
	m_mapView->Create(NULL, NULL, WS_CHILD | WS_DISABLED,
		  	            CFrameWnd::rectDefault, this,
					    AFX_IDW_PANE_FIRST, NULL);
	m_mapView->m_ubiView = this;
	cMap = m_mapView;
	GetDlgItem(IDC_FRAME)->GetWindowRect(&rectangle);
	ScreenToClient(&rectangle);
	bandit_flag = FALSE;
	Bandit_dir = 1;
	CopXflag = FALSE;
	CopYflag = FALSE;
	CheckRadioButton(IDC_RADIO_TARGET,IDC_RADIO_BANDIT,IDC_RADIO_START);
	m_mapView->SetWindowPos(NULL, rectangle.left, rectangle.top, 501, 501, 
							  SWP_NOZORDER | SWP_NOACTIVATE);
	m_mapView->EnableWindow(TRUE);
	m_mapView->ShowWindow(SW_SHOW);
    m_mapView->InvalidateRect(NULL);
    m_mapView->UpdateWindow();
}

void CUBIView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	if(firstView)
	{
		Online = FALSE;
		CreateMap();	
		CPort = new CSerialPort;
		InitPort();
		BeginCheminThread();
		m_Batterie.SetRange(0,230);
		m_Batterie.SetPos(0);
	}
	CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CUBIView::OnLButtonDown(UINT nFlags, CPoint point) 
{

}

void CUBIView::Print_LCD()
{
	m_LCD.SetWindowText("AffichageLCD");

}



int CUBIView::OnMouseActivate( CWnd*, UINT, UINT )
{
	return MA_NOACTIVATE;
}


void CUBIView::OnLButtonUp(UINT nFlags, CPoint point) 
{

	//CView::OnLButtonUp(nFlags, pt);
}

void CUBIView::OnButton2() 
{
	m_mapView->Reset_Obstacle_Reel();
}

void CUBIView::ShowTargetPos()
{
	//MessageBox("ShowTarget",0,0);
	CString tmp;
	tmp.Format("%i cm",Target.x);
	m_targetX.SetWindowText(tmp);
	tmp.Format("%i cm",Target.y);
	m_targetY.SetWindowText(tmp);

}


void CUBIView::OnGrid() 
{
	CMenu *menu;
	CFrameWnd* framewnd = GetParentFrame();
	menu = framewnd->GetMenu();
	if(menu->GetMenuState(ID_GRID,MF_BYCOMMAND) == MF_CHECKED)
	{
		menu->CheckMenuItem(ID_GRID,MF_UNCHECKED);
		grid = FALSE;
		m_mapView->ShowMap();
	}
	else
	{
		menu->CheckMenuItem(ID_GRID,MF_CHECKED);
		grid = TRUE;
		m_mapView->ShowMap();
	}
	// TODO: Add your command handler code here
	
}

void CUBIView::ShowCopPos()
{
	CopXflag = TRUE;
	CopYflag = TRUE;
	CString tmp;
	tmp.Format("%i cm",Cop.x);
	m_PosX.SetWindowText(tmp);
	tmp.Format("%i cm",Cop.y);
	m_PosY.SetWindowText(tmp);


}

void CUBIView::ShowCopSpeed()
{
	CString tmp, t1, t2;
	m_speedG.GetWindowText(t1);
	m_speedD.GetWindowText(t2);
	Sem_Vitesse.Lock();
	if(!(t1 == '0' && t2 == '0' && Robot_Vitesse_D == 0 && Robot_Vitesse_G == 0))
	{
		tmp.Format("%i",Robot_Vitesse_D);
		m_speedD.SetWindowText(tmp);
		tmp.Format("%i",Robot_Vitesse_G);
		m_speedG.SetWindowText(tmp);
	}
	Sem_Vitesse.Unlock();
}

void CUBIView::OnKillfocusX() 
{
	if(CopXflag)
		CopXflag = FALSE;
}

void CUBIView::OnButton1() 
{
	if(Online && CPort->m_bThreadAlive)
			MessageBox("Le port srie est en fonction","tat du port srie",MB_ICONINFORMATION);
	else
			MessageBox("Le port srie n'est pas en fonction","Attention!",MB_ICONSTOP);
}

void CUBIView::ShowRX(CString param)
{
	CString tmp;
	m_RX.GetWindowText(tmp);
	tmp += "\r\n";
	tmp += param;
	m_RX.SetWindowText(tmp);
	
}


void CUBIView::ShowTX(CString param)
{
	CString tmp;
	m_TX.GetWindowText(tmp);
	tmp += " ";
	tmp += param;
	m_TX.SetWindowText(tmp);
	
}


LONG CUBIView::OnRX(WPARAM ch, LPARAM port)
{
	Vecteur retour;
	double deltaX, deltaY;
	int Infra_g = 0;
	int Infra_d = 0;
	int pX, pY;		// sortie du perceptron
	int j;
	CString tmp;
	tmp.Format("%c",ch);
	ShowRX(tmp);
	switch(state)
	{
	case 2: 
		if(delai == 1) // 2e byte du delai1
			delai1 = (ch << 8) + lastchar;
		if(delai == 3) // 2e byte du delai2
			delai2 = (ch << 8) + lastchar;
		if(delai == 5) // 3e byte du delai3
			delai3 = (ch << 8) + lastchar;
		if(delai == 7) // 3e byte du delai4
			delai4 = (ch << 8) + lastchar;
		delai++;

		if(delai == 8)
		{
			state++;
			delai = 0;

			donnee[0] = (float)delais(delai1, delai2, 4) * 0.0000005;
			donnee[1] = (float)delais(delai2, delai3, 4) * 0.0000005;
			donnee[2] = (float)delais(delai3, delai4, 4) * 0.0000005;
			
			while(donnee[0] <= 0.134)
				donnee[0] += 0.032768;   // 65536 x 500ns 

			while(donnee[1] <= 0.134)
				donnee[1] += 0.032768;   // 65536 x 500ns 

			while(donnee[2] <= 0.134)
				donnee[2] += 0.032768;   // 65536 x 500ns 
		
			/////////////////////Prendre les chatillons////////////////
//			EcrireEchantillon();
			////////////////////////////////////////////////////////////			
			
			// Calcul de la position avec le perceptron
			reseaux.TesterReseaux(donnee[0], donnee[1], donnee[2], retour);
			Sem_Position.Lock();

			if(retour[0]<0)
			   retour[0]=0;
			if(retour[0]>499)
			   retour[0]=499;
			if(retour[1]<0)
			   retour[1]=0;
			if(retour[1]>499)
			   retour[1]=499;

            pX = retour[1];
            pY = retour[0];

            deltaX = m_Robot_Pre_X - pX;
			deltaY = m_Robot_Pre_Y - pY;
        //Pour ne pas que le robot oscille inutilement
      if((deltaX*deltaX + deltaY*deltaY) > 625)// && (deltaX*deltaX + deltaY*deltaY)<2500)
        {
			  Cop.x = m_Robot_Pre_X = pX;
		  	Cop.y = m_Robot_Pre_Y = pY;

			  Robot_X = (m_Robot_Pre_X - ((int)m_Robot_Pre_X%(500/dimension)))/(500/dimension);
			  Robot_Y = (m_Robot_Pre_Y - ((int)m_Robot_Pre_Y%(500/dimension)))/(500/dimension);

			  cMap->ShowMap();
        }

			Sem_Position.Unlock();

			// Validation de la nouvelle position	
/*
            deltaX = m_Robot_Pre_X - pX;
			deltaY = m_Robot_Pre_Y - pY;
			if((deltaX*deltaX + deltaY*deltaY) <= rayon*rayon)
			{
       			if((deltaX*deltaX + deltaY*deltaY) <= rayon*rayon)
       			{
    				// La position est valide
	    			m_Robot_Pre_X = pX;
		    		m_Robot_Pre_Y = pY;

			}
*/
			// Affichage de la position
			ShowCopPos();
		
		}
		
		break;
	case 3: //Etat de reception d'un obstacle (Bumper)
		if(ch &  0x01)
			Infra_g = 1;
		if(ch & 0x02)
			Infra_d = 1;
		if(Infra_g == 1 || Infra_d == 1)
			Update_MAP(Infra_g, Infra_d);
		delai = 0;
		Sem_Vitesse.Lock();
        SendData(Robot_Vitesse_G,Robot_Vitesse_D,Robot_Rotation);
		rotation_flag = FALSE;
		Robot_Rotation = 0;
		Sem_Vitesse.Unlock();
		state++;
		break;
	case 4: //Etat de reception du ONLINE du robot
		m_Batterie.SetPos(ch);
    state = 2;
		break;
 	case 5: //Obstacle par InfroRouge
		if(ch &  0x01)
			Infra_g = 1;
		if(ch & 0x02)
			Infra_d = 1;
		if(Infra_g == 1 || Infra_d == 1)
			Update_MAP(Infra_g, Infra_d);
		delai = 0;
		Sem_Vitesse.Lock();
        SendData(Robot_Vitesse_G,Robot_Vitesse_D,Robot_Rotation);
		rotation_flag = FALSE;
		Robot_Rotation = 0;
		Sem_Vitesse.Unlock();
    state = 2;
		break;

	default:
		state = 2;
		delai = 0;
		break;
	}
	//lastchar = ch;
	return 0;
}


void CUBIView::BeginCheminThread()
{
	stop = TRUE;
	ACthread = AfxBeginThread(Algo_Chemin, &stop, THREAD_PRIORITY_LOWEST, 0, NULL );
}

void CUBIView::OnButton3() 
{
	simflag = TRUE;
	stop = TRUE;
	Simthread = AfxBeginThread(Simulation, this,THREAD_PRIORITY_LOWEST, 0, NULL );
	
}

BOOL CUBIView::InitPort()
{
	CString com;
	Port sPort;
	sPort.LoadParam();
	// Initialisation du port
	if(CPort->m_bThreadAlive)
	{
		CPort->StopMonitoring();
		delete CPort;
		CPort = new CSerialPort;
	}
	if(CPort->InitPort(this, sPort.portID,sPort.baud))
	{
		Online = TRUE;
		delai = 0;
		state = 2;
		CPort->StartMonitoring();
	}
	else
	{
		Online = FALSE;
		MessageBox("Le port slectionn ne peut-tre utilis.","Attention",MB_ICONWARNING);
		return 1;
	}
	return 0;
}

void CUBIView::OnParamComm() 
{
	CommDlg comm;
	comm.m_hView = (CUBIView*)this;
	comm.DoModal();
}

void CUBIView::SendData(int vg, int vd, int rot)
{
	CString cmd;
	char byte;
	char bt;
	bt = 0;
	////////////////////////////////////
	// Dfinition du protocole
	// bit 8:	batterie, 0 = demande 1= standby
	// bit 7-5:	angle de rotation
	//	000: +0  degr
	//	001: +45 degr
	//	010: +90 
	//	011: +135
	//	100: -135 
	//	101: -90
	//	110: -45
	// bit 4-3: vitesse droite, bit 2-0: vitesse gauche
	// 000: 0
	// 001: 1
	// 010: 2
	// 011: 3
	byte = 128;
	byte += rot << 4;
	byte += vd << 2;
	byte += vg;
//	if(Online)// && simflag)
//	{
		cmd.Format("%c",bt);
		CPort->WriteToPort(&byte);
		cmd.Format("%i",byte);
		ShowTX(cmd);
//	}
}


void CUBIView::OnPanic() 
{
	simflag = FALSE;
	SendData(0,0,0);
	//SetTimer(1,125,0);
}


void CUBIView::OnButton7() 
{
	// TODO: Add your control notification handler code here
	m_mapView->Reset_Obstacle_Virt();
}

BEGIN_EVENTSINK_MAP(CUBIView, CView)
    //{{AFX_EVENTSINK_MAP(CUBIView)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


void CUBIView::OnPlay() 
{
	simflag = TRUE;
	stop = TRUE;
	Simthread = AfxBeginThread(Simulation, this,THREAD_PRIORITY_LOWEST, 0, NULL );
	
}


void CUBIView::OnButton4() 
{
/*
	CStdioFile fichier;
	CFileException e;
	CString buffer;

	if(!fichier.Open("Temps.txt", CFile::modeWrite | CFile::typeText, &e))
	{
		AfxMessageBox("Erreur dans bouton 4", MB_OK);
		return;
	}
	fichier.SeekToEnd();

	px = ((compteur2/6))*100;
	py = ((compteur2%6))*100;


	fichier.WriteString("\n");

	fichier.Close();
*/		
	//SendData(Robot_Vitesse_G,Robot_Vitesse_D,0);
	SendData(0,0,0);

}

void CUBIView::OnTimer(UINT nIDEvent) 
{
	KillTimer(1);
	MessageBox("OnTimer",0,0);
	CView::OnTimer(nIDEvent);

}
//Ecrire dans un fichier les chantillons
void CUBIView::EcrireEchantillon()
{
	CStdioFile fichier;
	CFileException e;
	CString buffer;
	if(!fichier.Open("Temps.txt", CFile::modeWrite | CFile::typeText, &e))
	{
		buffer.Format("Erreur d'ouverture : %d",e.m_cause);
		AfxMessageBox(buffer, MB_OK);
		return;
	}
	fichier.SeekToEnd();

	int i;

	fichier.WriteString("(3,1) ");

	for(i=0;i<3;i++)
	{
		buffer.Format("%f ",donnee[i]);
		fichier.WriteString(buffer);
	}
	fichier.WriteString("\n");

	buffer.Format("(2,1) %d %d",px,py);
	fichier.WriteString(buffer);  
	fichier.WriteString("\n");
	compteur1++;
	if(compteur1==6)
	{
		compteur2++;
		compteur1=0;
//		fichier.WriteString("\n");
//		fichier.WriteString("\n");		
	}		
	fichier.Close();

}

void CUBIView::OnReseaux() 
{
	// TODO: Add your control notification handler code here
	reseaux.DoModal();
}

void CUBIView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	MessageBox("Keydown");	
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CUBIView::OnRadioBandit() 
{
	SetFocus();	
}

void CUBIView::OnKillFocus(CWnd* pNewWnd) 
{
	CView::OnKillFocus(pNewWnd);
}

void CUBIView::OnSetFocus(CWnd* pOldWnd) 
{
	CView::OnSetFocus(pOldWnd);
}

void CUBIView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	MessageBox("YES!!!");	
	CView::OnChar(nChar, nRepCnt, nFlags);
}

